# Check for the SBML library and headers and set ${libsbml_found} to
# "yes" if it was found.  Because libSBML depends on either expat or
# Xerces-C++, those are checked for here as well, and either
# "HAVE_EXPAT" or "HAVE_XERCES_C" is set correspondingly in the config
# file.  Note that one should not set both, even if both libraries are
# installed.  Additionally, ${with_xml_library} is set to either
# "expat", "xerces-c" or the empty string, depending on what library
# the user requested.  The library libSBML was linked with is stored
# in ${libsbml_xml_library}.  The "XML_CPPFLAGS", "XML_LDFLAGS" and
# "XML_LIBS" are set accordingly.
#
# FIXME!! This file should probably be renamed to "ax_check_libsbml.m4"

AC_DEFUN([AX_CHECK_LIBSBML],
[
  AC_ARG_WITH([libsbml],
    AC_HELP_STRING([--with-libsbml],
                   [use libSBML SBML library [[yes]]]),
    [with_libsbml=${withval}],
    [with_libsbml=yes])
#   removing xml checks in general...
#   AH_TEMPLATE([HAVE_EXPAT],
#               [Define to 1 you have the expat XML library.])
#   AH_TEMPLATE([HAVE_XERCES_C],
#               [Define to 1 you have the Xerces-C++ XML library.])


  # Unless the user requested libSBML, there is not much to do here.
  # This should result in an error in the caller, as libSBML is
  # required.  Then check what XML libraries are installed, and look
  # for the libSBML headers.

  
   if test "X${with_libsbml}" != "Xno"; then
# removing xml checks....     
#     AX_CHECK_EXPAT
#     AX_CHECK_XERCES_C

    if test "X${with_libsbml}" != "Xyes"; then
      if test -d ${with_libsbml}/include; then
        CPPFLAGS="-I${with_libsbml}/include ${CPPFLAGS}"
      fi
      if test -d ${with_libsbml}/lib; then
        LDFLAGS="-L${with_libsbml}/lib ${LDFLAGS}"
      fi
    fi
    LIBSBML_LIBS="-lsbml"

    AC_LANG_PUSH([C])

    AC_CHECK_HEADERS([sbml/common/libsbml-config-unix.h],
                     [libsbml_headers_found=yes],
                     [libsbml_headers_found=no])


    # See if libSBML was compiled with expat support.  If it was,
    # USE_EXPAT will be defined in libsbml-config-unix.h.  Otherwise,
    # libSBML must have been compiled with Xerces-C++ support.


     if test "X${libsbml_headers_found}" == "Xyes"; then
# removing xml checks....
#       AC_MSG_CHECKING([for XML library in sbml/common/libsbml-config-unix.h])
#       AC_TRY_LINK(
#         [#include <sbml/common/libsbml-config-unix.h>],
#         [#ifdef USE_EXPAT
#            foo
#          #endif],
#         [libsbml_xml_library=xerces-c],
#         [libsbml_xml_library=expat])
#       AC_MSG_RESULT([${libsbml_xml_library}])

#       if test "X${expat_found}"    != "Xyes" \
#            -a "X${xerces_c_found}" == "Xyes"; then
#         # expat is not installed, so one will have to use Xerces-C++.
#         with_xml_library="xerces-c"

#       elif test "X${expat_found}"    == "Xyes" \
#              -a "X${xerces_c_found}" != "Xyes"; then
#         # Xerces-C++ is not installed, so one will have to use expat.
#         with_xml_library="expat"

#       elif test "X${expat_found}"    == "Xyes" \
#              -a "X${xerces_c_found}" == "Xyes"; then

#         # Both expat and Xerces-C++ are installed.  Chose the one that
#         # was explicitely enabled by the user.  If both or none were
#         # enabled, chose the one that was used to compile libSBML.
#         if test "X${with_expat}"    != "X" \
#              -a "X${with_xerces_c}" == "X"; then
#           with_xml_library="expat"
#         elif test "X${with_expat}"    == "X" \
#                -a "X${with_xerces_c}" != "X"; then
#           with_xml_library="xerces-c"
#         else
#           with_xml_library=${libsbml_xml_library}
#         fi
#       fi

#       case "X${with_xml_library}" in
#         "Xexpat")
#           XML_LIBS=${EXPAT_LIBS}
#           AC_DEFINE([HAVE_EXPAT], [1], [])
#           ;;
#         "Xxerces-c")
#           XML_LIBS=${XERCES_C_LIBS}
#           AC_DEFINE([HAVE_XERCES_C], [1], [])
#           ;;
#       esac

      # Add the relevant XML library to ${LIBS} and check that linking
      # against libSBML is OK.

      LIBS_tmp="${LIBS}"
      LIBS="${XML_LIBS} ${LIBS}"
      AC_CHECK_LIB([sbml],
                   [Model_create],
                   [libsbml_lib_found=yes],
                   [libsbml_lib_found=no])
      LIBS="${LIBS_tmp}"

      libsbml_found="no"
      if test "X${libsbml_headers_found}" == "Xyes" \
           -a "X${libsbml_lib_found}"     == "Xyes"; then
        libsbml_found="yes"
      fi

      AC_LANG_POP([C])

      AC_SUBST([LIBSBML_LIBS])
      AC_SUBST([XML_LIBS])

      AC_SUBST([libsbml_found])
      AC_SUBST([libsbml_xml_library])
      AC_SUBST([with_xml_library])
    fi
  fi
])
