# Filters out duplicate compiler flags.  Based on libshout's
# XIPH_CLEAN_CCFLAGS macro by Brendan Cully.  The first argument is
# the dirty flags, the second is the clean flags.

AC_DEFUN([AX_CLEAN_FLAGS],
[
  clean_flags=""
  dirty_flags="$1"


  # Append each flag in ${dirty_flags} to ${clean_flags} unless it
  # already present there.

  for flag in ${dirty_flags}; do
    if echo ${clean_flags} | grep -v -- ${flag} > /dev/null; then
      clean_flags="${clean_flags} ${flag}"
    fi
  done


  # Output ${clean flags} to the second argument.

  for flag in ${clean_flags}; do
    if echo ${2} | grep -v -- ${flag} > /dev/null; then
      $2="$$2 ${flag}"
    fi
  done
])
