/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* Copyright (c) 2004-2007, Johan Elf, David Fange, Johan Hattne
 *
 * Permission to use, copy, modify, and/or distribute this software
 * for any purpose with or without fee is hereby granted, provided
 * that the above copyright notice and this permission notice appear
 * in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
 * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * $Id: SignalHandler.cpp 533 2007-10-24 09:55:48Z hattne $
 */
#include "SignalHandler.hpp"


  /* Initialise the static data members.  Apparently this is not
   * required on some compilers.  However, the ANSI standard says that
   * static data members should always be initialised.
   *
   * It is important to initialise <code>ptr</code> to null, since at
   * initialisation, there is no instance of the SignalHandler
   * singleton class.
   */
MesoRD::SignalHandler* MesoRD::SignalHandler::ptr = 0;
std::map<int, MesoRD::EventHandler*> MesoRD::SignalHandler::handlers
= std::map<int, MesoRD::EventHandler*>();


  /* For technical reasons one should always provide a non-inline
   * implementation for virtual destructors, even if it is trivial.
   * This will make sure that the compiler generates a vtable.
   * Without a vtable, there will be unresolved symbols when it comes
   * to linking.
   */
MesoRD::EventHandler::~EventHandler()
{}
