/* The WoeGetOpt class.
 *
 * Copyright 2004 Johan Elf, Johan Hattne
 *
 * This file is part of MesoRD.
 *
 * MesoRD is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesoRD is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MesoRD; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * $Id: WoeGetOpt.hpp 559 2008-09-10 19:46:33Z davidfange $
 */
#ifndef __WinGetOpt_H
#define __WinGetOpt_H

#include <string>

#include "GetOpt.hpp"

namespace MesoRD {

    /**
     * Class for modeling cubic sub volumes.
     *
     * Abstraction layer that is supposed to hide the fact that
     * different operating systems are solving the same task in
     * differently stupid ways.
     */
  class WoeGetOpt : public GetOpt {
  public:
    WoeGetOpt(HINSTANCE hInstance, HWND hwnd, int nCmdShow, GetOpt* op);
    ~WoeGetOpt();

    void displayHelp() const {};

	void displayVersion() const {};

    friend BOOL CALLBACK
      OptionDialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
  };
}

#endif
