/* The WoeGetOpt class.
 *
 * Copyright 2004 Johan Elf, Johan Hattne
 *
 * This file is part of MesoRD.
 *
 * MesoRD is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesoRD is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MesoRD; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * $Id: WoeProgressBar.hpp 542 2008-04-15 19:35:37Z davidfange $
 */

#ifndef __TextProgressBar_H
#define __TextProgressBar_H

#include <string>

#include <valarray>
#include <windows.h>

#include "ProgressBar.hpp"

namespace MesoRD {


    /**
     * Class for modeling cubic sub volumes.
     *
     * Abstraction layer that is supposed to hide the fact that
     * different operating systems are solving the same task in
     * differently stupid ways.
     */
  class WoeProgressBar : public ProgressBar {
  private:
    bool alive;
    HWND handle_progress;

  public:
    WoeProgressBar(HINSTANCE hInstance, HWND hwnd, int nCmdShow);
    ~WoeProgressBar();

//    void draw();
    void setFraction(const double fraction);
    void setIteration(const std::valarray<size_t>& iteration);
    void setTime(const double time);
    void setTitle(const std::string& title);

    bool isAlive();
    void run();
    void stop();

	friend BOOL CALLBACK ProgressBarDialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
  };
}

#endif
