/* The TestAnnotation class.
 *
 * Copyright 2004-2008 Johan Elf, David Fange, Johan Hattne
 *
 * This file is part of MesoRD.
 *
 * MesoRD is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesoRD is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MesoRD; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * $Id: TestParameter.hpp 541 2008-04-12 18:52:41Z davidfange $
 */
#ifndef MESORD_TESTANNOTATION_H
#define MESORD_TESTANNOTATION_H 1

#include <cppunit/extensions/HelperMacros.h>

#include "../src/Annotation.hpp"
#include <sbml/SBMLReader.h>

class TestAnnotation : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( TestAnnotation );
  CPPUNIT_TEST( testConstructor );
  CPPUNIT_TEST( testGetSet ); 
  CPPUNIT_TEST_EXCEPTION( testGetBoolAttributeThrow1,
    MesoRD::Annotation::InvalidFormat<bool>);
  CPPUNIT_TEST_EXCEPTION( testGetBoolAttributeThrow2,
    MesoRD::Annotation::AttributeNotFound);
  CPPUNIT_TEST_EXCEPTION( testGetDoubleAttributeThrow1,
    MesoRD::Annotation::InvalidFormat<double>);
  CPPUNIT_TEST_EXCEPTION( testGetDoubleAttributeThrow2,
    MesoRD::Annotation::AttributeNotFound);
  CPPUNIT_TEST_EXCEPTION( testGetFloatAttributeThrow1,
    MesoRD::Annotation::InvalidFormat<float>);
  CPPUNIT_TEST_EXCEPTION( testGetFloatAttributeThrow2,
    MesoRD::Annotation::AttributeNotFound);

  
//  CPPUNIT_TEST( testIsFunctions );
  CPPUNIT_TEST_SUITE_END();

private:

  Model* m;

public:
  void setUp();
  void tearDown();

  void testConstructor();
  void testGetSet();
  void testGetBoolAttributeThrow1();
  void testGetBoolAttributeThrow2();
  void testGetDoubleAttributeThrow1();
  void testGetDoubleAttributeThrow2();
  void testGetFloatAttributeThrow1();
  void testGetFloatAttributeThrow2();
  
//  void testIsFunctions();
};

#endif  // MESORD_TESTANNOTATION_H
