/* The TestReactionNodeException class.
 *
 * Copyright 2004-2008 Johan Elf, David Fange, Johan Hattne
 *
 * This file is part of MesoRD.
 *
 * MesoRD is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesoRD is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MesoRD; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * $Id: TestReactionNodeExceptions.hpp 553 2008-05-09 13:28:22Z davidfange $
 */
#ifndef MESORD_TESTREACTIONNODEEXCEPTION_HPP
#define MESORD_TESTREACTIONNODEEXCEPTION_HPP 1

#include <cppunit/extensions/HelperMacros.h>

#include "../src/reaction/ReactionNode.hpp"
#include "../src/SpeciesTable.hpp"
#include "../src/ParameterTable.hpp"

#include <sbml/SBMLReader.h>

class TestReactionNodeException : public CppUnit::TestFixture
{

  CPPUNIT_TEST_SUITE( TestReactionNodeException );
    /*CPPUNIT_TEST_EXCEPTION( testParameterThrow, 
    MesoRD::ReactionNode::UndefinedIdentifier );
  CPPUNIT_TEST_EXCEPTION( testUnknownThrow,  
    MesoRD::ReactionNode::ModelError );
  CPPUNIT_TEST_EXCEPTION( testAbsGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testCeilGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testExpGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testFactorialGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testFloorGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testLnGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testLogGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testPowerGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
*/
  CPPUNIT_TEST_EXCEPTION( testRootGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testPlusGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testMinusGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testEqGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testGeqGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testGtGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testLeqGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testLtGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testNeqGetUnitThrow, 
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testAbsRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testCeilRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testExpRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testFloorRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testFactorialRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testLnRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testLogRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testPowerRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testRootRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testAndRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testNotRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testOrRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testXorRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testPlusRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testMinusRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testTimesRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testDivisionRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testEqRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testGeqRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testGtRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testLeqRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testLtRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testNeqRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  CPPUNIT_TEST_EXCEPTION( testArccosRefoldThrow,
    MesoRD::ReactionNode::InvalidUnit );
  
  CPPUNIT_TEST_SUITE_END();

private:

  Model* m;
  ListOfUnitDefinitions* uds;

  MesoRD::SpeciesTable st;
  MesoRD::ParameterTable pt;
  
  std::valarray<unsigned int> val_int;
  std::valarray<double> val_double;

  
public:
  void setUp();
  void tearDown();
  

    /*void testParameterThrow();
  void testUnknownThrow();
  void testAbsGetUnitThrow();
  void testCeilGetUnitThrow();
  void testExpGetUnitThrow();
  void testFloorGetUnitThrow();
  void testFactorialGetUnitThrow();
  void testLnGetUnitThrow();
    */
  void testLogGetUnitThrow();
  void testPowerGetUnitThrow();
  void testRootGetUnitThrow();
  void testPlusGetUnitThrow();
  void testMinusGetUnitThrow();
  void testEqGetUnitThrow();
  void testGeqGetUnitThrow();
  void testGtGetUnitThrow();
  void testLeqGetUnitThrow();
  void testLtGetUnitThrow();
  void testNeqGetUnitThrow();
  
  void testAbsRefoldThrow();
  void testCeilRefoldThrow();
  void testExpRefoldThrow();
  void testFloorRefoldThrow();
  void testFactorialRefoldThrow();
  void testLnRefoldThrow();
  void testLogRefoldThrow();
  void testPowerRefoldThrow();
  void testRootRefoldThrow();
  void testAndRefoldThrow();
  void testNotRefoldThrow();
  void testOrRefoldThrow();
  void testXorRefoldThrow();
  void testPlusRefoldThrow();
  void testMinusRefoldThrow();
  void testTimesRefoldThrow();
  void testDivisionRefoldThrow();
  void testEqRefoldThrow();
  void testGeqRefoldThrow();
  void testGtRefoldThrow();
  void testLeqRefoldThrow();
  void testLtRefoldThrow();
  void testNeqRefoldThrow();
  void testArccosRefoldThrow();

};

#endif // MESORD_TESTREACTIONNODEEXCEPTION_H
