
/* The TestSpecies class.
 *
 * Copyright 2004-2008 Johan Elf, David Fange, Johan Hattne
 *
 * This file is part of MesoRD.
 *
 * MesoRD is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesoRD is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MesoRD; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * $Id: TestSpecies.hpp 553 2008-05-09 13:28:22Z davidfange $
 */
#ifndef MESORD_TESTSPECEIS_HPP
#define MESORD_TESTSPECIES_HPP 1

#include <cppunit/extensions/HelperMacros.h>

#include "../src/Species.hpp"
#include <sbml/SBMLReader.h>

class TestSpecies : public CppUnit::TestFixture
{

  CPPUNIT_TEST_SUITE( TestSpecies );
  CPPUNIT_TEST( testConstructor );
  CPPUNIT_TEST_EXCEPTION( testConstructorUnknownSubstanceThrow,
    MesoRD::Species::ModelError );
  CPPUNIT_TEST_EXCEPTION( testConstructorSubstConvertThrow, 
    MesoRD::Species::ModelError );
  CPPUNIT_TEST_EXCEPTION( testConstructorConcConvertThrow,
    MesoRD::Species::ModelError );
  CPPUNIT_TEST_EXCEPTION( testConstructorDiffUnitThrow,
    MesoRD::Species::ModelError );
  CPPUNIT_TEST_EXCEPTION( testConstructorDiffUnitConvertThrow,
    MesoRD::Species::ModelError );

  CPPUNIT_TEST( testGetSets );
  CPPUNIT_TEST( testIsFunctions );

  CPPUNIT_TEST_SUITE_END();
private:

  Model* m;
  ListOfUnitDefinitions* uds;
  ListOf ps;
  

public:
  void setUp();
  void tearDown();

  void testConstructor();
    
  void testConstructorUnknownSubstanceThrow();
  void testConstructorSubstConvertThrow();
  void testConstructorConcConvertThrow();
  void testConstructorDiffUnitThrow ();
  void testConstructorDiffUnitConvertThrow();

  void testGetSets();
  void testIsFunctions();

};

#endif  // MESORD_TESTSPECIES_H
