/* The TestSpeciesTable class.
 *
 * Copyright 2004-2005 Johan Elf, David Fange, Johan Hattne
 *
 * This file is part of MesoRD.
 *
 * MesoRD is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesoRD is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MesoRD; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * $Id: TestSpeciesTable.hpp 550 2008-05-07 14:24:19Z davidfange $
 */
#ifndef MESORD_TESTSPECEISTABLE_HPP
#define MESORD_TESTSPECIESTABLE_HPP

#include <cppunit/extensions/HelperMacros.h>

#include "../src/SpeciesTable.hpp"
#include <sbml/SBMLReader.h>

class TestSpeciesTable : public CppUnit::TestFixture
{

  CPPUNIT_TEST_SUITE( TestSpeciesTable );
  CPPUNIT_TEST( testAddSpecies );
  CPPUNIT_TEST( testIsFunctions );
  CPPUNIT_TEST( testGetSets );
  CPPUNIT_TEST( testChangeFunctions );
  CPPUNIT_TEST_SUITE_END();

private:

public:
  void setUp();
  void tearDown();

  void testAddSpecies();
  void testIsFunctions();
  void testGetSets();
  void testChangeFunctions();
  
  
};

#endif  // MESORD_TESTSPECIESTABLE_H
